#!/bin/sh

# Get the directory where this script resides.
WORK_DIR=$(cd `dirname $0` && pwd)

# Build T2C code generator
cd ${WORK_DIR}/t2c
chmod +x ./*.sh
T2C_ROOT=${WORK_DIR} ./build.sh 

if [ $? -ne 0 ] 
then
	echo "Unable to build T2C code generator."
	exit 1 
fi

# Build T2C ReqMarkup plugin for KompoZer/Nvu
cd ${WORK_DIR}/reqmarkup
chmod +x ./*.sh 
./build.sh

# Done
echo "Build completed successfully."
