var gActiveEditor;
var dialogNode;

var setLastIdUsed;

var reqs;//array of all elements in reqs
var listBoxReqs;//array of index in reqs, corresponding to listbox of existing reqs

/*
 * Contains mode of dialog:
 *  -"view" - view existing requirements, can modify them
 *  -"add" - adding new requirement, can view existing ones, but cannot modify them
*/

var mode;

/*
 * Contains submode of dialog - whether selection in listbox is empty or not
*/

var selectionIsEmpty = true;

// dialog initialization code(initialization of common variables)
function Startup()
{
    mode = window.arguments[0];
    
    dialogNode = document.getElementById("reqDlg");
    
    gActiveEditor = GetCurrentEditor();
    if (!gActiveEditor)
    {
        dump("Failed to get active editor!\n");
        window.close();
        return;
    }
    gDialog.idInput          = document.getElementById("idInput");
    gDialog.reqOrigTextInput = document.getElementById("reqOrigTextInput");
    gDialog.reqAltTextInput  = document.getElementById("reqAltTextInput");
    gDialog.currentIds       = document.getElementById("currentIds");
    gDialog.filterExprInput  = document.getElementById("filterExprInput");

	InitDialog(mode);

    SetWindowLocation();
}
//initilalize dialog fields according to the mode
function InitDialog(mode)
{
    InitReqsList();
    showIdsList("");        

    setLastIdUsed = window.arguments[2];

    if(mode == "view")
    {
    	gDialog.idInput.readonly = true;
    	dialogNode.getButton("accept").label = "Overwrite";
    	dialogNode.getButton("extra2").label = "Delete";
    	dialogNode.getButton("accept").disabled = true;
    	dialogNode.getButton("extra2").disabled = true;

    	var selectedElem = window.arguments[1];

    	var selectedIndex = selectedElem ? searchReqElem(selectedElem) : -1;
    	if(selectedIndex == -1) selectedIndex = 0;//default selection

    	selectReq(selectedIndex);
    	
		return;
    }
    //mode == "add"
	dialogNode.getButton("accept").label = "Add";
    dialogNode.getButton("extra2").label = "Restore";
    dialogNode.getButton("accept").disabled = true;
    dialogNode.getButton("extra2").disabled = true;

    var lastIdUsed = window.arguments[1]();

	var reqOrigText;
	try
	{
		//create temporary element for interpret formulation of added req via getElementText
		var document = gActiveEditor.document;
		var tmp_elem = document.createElement("span");
	    tmp_elem.innerHTML = gActiveEditor.outputToString("text/html", 1);
	    gDialog.reqOrigTextInput.value = getElementText(tmp_elem, document);
	}
	catch(error)
	{
		window.alert("Error when interpret requirement: " + error.message);
		gDialog.reqOrigTextInput.value = gActiveEditor.outputToString("text/plain", 1);
	}
    
    if(lastIdUsed && lastIdUsed != "") gDialog.idInput.value = lastIdUsed;
    else if (reqs.length) gDialog.idInput.value = reqs[0].str_id;

    onInc();//automatically call idChanged()
}
//called when content of gDialog.idInput is changed by user
function IdChanged()
{
    //window.alert("IdChanged() was called, selectionIsEmpty is " + selectionIsEmpty);
    if(mode == "view") return;//operation should not arised here
	//mode == "add"
	if(!selectionIsEmpty)
	//if(dialogNode.getButton("extra2").disabled == false)    
	{
	    //bypass situation when oninput event emitted even when id change programically
	    if(gDialog.currentIds.selectedItem && gDialog.idInput.value == gDialog.currentIds.selectedItem.label)return;
	    //restore properties of new req, if need
	    //because reason of the restoring is id changing, id should't be restored
	    storeText(gDialog.idInput);
	    gDialog.currentIds.clearSelection();//restoring via callback function onSelected()
    }
    else
    {
    	updateAddButton();
    }
}
//called when selection in listbox, containing identifiers of existing requirements, changed
function onSelected(lb)
{   
    var selectedItem = lb.selectedItem;
    //dump("onSelected(), selectionIsEmpty:" + selectionIsEmpty +";selected item: " + selectedItem);
    //window.alert("onSelected(), selectionIsEmpty:" + selectionIsEmpty +";selected item: " + selectedItem);
    if(mode == "add")
    {
	    if(!selectedItem)
	    {
    		//whether switching
    		if(!selectionIsEmpty)
    		{
				//deselection - restore content of adding req
				//dump("switching to deselect");
				restoreText(gDialog.reqOrigTextInput);
				restoreText(gDialog.reqAltTextInput);
				restoreText(gDialog.idInput);

				gDialog.idInput.style.color='rgb(0, 0, 0)';
				dialogNode.getButton("extra2").disabled = true;
				gDialog.reqAltTextInput.readonly = false;
				
				selectionIsEmpty = true;
			}
			updateAddButton();
			
			//dump("onSelected() finished, selectionIsEmpty:" + selectionIsEmpty +";selected item: " + selectedItem);
	    	return;
	    }
	    //whether switching
	    if(selectionIsEmpty)
    	{
		    //store properties of adding req
			//dump("switching to select");
		    storeText(gDialog.reqOrigTextInput);
			storeText(gDialog.reqAltTextInput);
			storeText(gDialog.idInput);
		    //
		    dialogNode.getButton("extra2").disabled = false;
		    gDialog.reqAltTextInput.readonly = true;
		    gDialog.idInput.style.color='rgb(255, 0, 0)';
		    
		    selectionIsEmpty = false;
	    }
	    dialogNode.getButton("accept").disabled = true;
    }
    else//mode == "view"
    {
    	if(!selectedItem)
	    {
	    	//whether switching
	    	if(!selectionIsEmpty)
    		{
		    	//deselection - clear fields
		    	gDialog.idInput.value = "";
	    		gDialog.reqOrigTextInput.value = "";
	    		gDialog.reqAltTextInput.value = "";
		    	
		    	dialogNode.getButton("accept").disabled = true;
		    	dialogNode.getButton("extra2").disabled = true;
		    	
		    	selectionIsEmpty = true;
	    	}
	    	return;
	    }
   	    //whether switching
	    if(selectionIsEmpty)
    	{
	    	dialogNode.getButton("accept").disabled = false;
		    dialogNode.getButton("extra2").disabled = false;

	    	selectionIsEmpty = false;
	    }
    }
    //selectionItem != null
    //common part for add and view - load content of selected req
	var selectedReq = getReqElem(selectedItem);
    
    gDialog.reqOrigTextInput.value = getElementText(selectedReq);
    gDialog.reqAltTextInput.value = getElementTextAlt(selectedReq);
    gDialog.idInput.value = selectedItem.label;
    
    //dump("onSelected() finished, selectionIsEmpty:" + selectionIsEmpty +";selected item: " + selectedItem);
}
//called when dialog is accepted(button "accept" was pressed, or key "enter" was pressed...)
function onAccept()
{
    reqAltText = TrimString(gDialog.reqAltTextInput.value);

    if(mode == "view")
    {
        var selectedItem = gDialog.currentIds.selectedItem;
        if(!selectedItem) return false;//this command not allowed when selection is empty
        overwriteReq(getReqElem(selectedItem), reqAltText);
        
        onSelected(gDialog.currentIds);//refresh requirement text
        return false;//do not close dialog
    }
    else//mode == "add"
    {
        var reqId = TrimString(gDialog.idInput.value);
        if(!ValidateData(reqId)) return false;//incorrect data for adding

        addReq(reqId, reqAltText);
        
        var lastIdUsed = reqId;
        setLastIdUsed(lastIdUsed);
        
        SaveWindowLocation();
        return true;
    }
}
//called when button "extra2" was pressed
function onExtra2()
{
    if(mode == "add")
    {
    	gDialog.currentIds.clearSelection();
    	return;
    }
    //mode == "view" - delete req
    var selectedItem = gDialog.currentIds.selectedItem;
    if(!selectedItem) return false;//this command not allowed when selection is empty 
    
    if (!confirm("Are you sure you want to delete this requirement?")) return false;//user cancel operation

    setLastIdUsed(selectedItem.label);
    
    //gDialog.currentIds.setAttribute("suppressonselect", "true");
    try
    {
    	var indexInListBox = gDialog.currentIds.selectedIndex;
    	var indexInReqs = listBoxReqs[indexInListBox];
    	var deletingElem = getReqElem(selectedItem);
    	
    	gDialog.currentIds.removeItemAt(indexInListBox);//remove element from listbox
    	listBoxReqs.splice(indexInListBox, 1);//remove element from array which link listbox with reqs
    	reqs.splice(indexInReqs, 1);//remove element from reqs
    	for(var i = indexInListBox; i < listBoxReqs.length; i++) listBoxReqs[i]--;//adjust content of linking array(according to reqs)
    	deleteReq(deletingElem);//remove req from document
    	selectReq(indexInListBox);//adjust selection
    }
    catch(error)
    {
    	window.alert("Error while deleting requirement: " + error.message);
    }
}
//********************Auxiliary functions*************************
//store content of the textbox
function storeText(textbox)
{
	//attribute "value" contains default value of the textbox, but property "value" contains current value of the textbox
	textbox.setAttribute("value", textbox.value);
}
//restore content of the textbox
function restoreText(textbox)
{
	textbox.value = textbox.getAttribute("value");
}
//return "req"-element, associated with item in list of current Ids
function getReqElem(item)
{
	var index = gDialog.currentIds.getIndexOfItem(item);
	return reqs[listBoxReqs[index]].c;
}
//
function InitReqsList()
{
	reqs = GetReqs(gActiveEditor.document);
	reqs.reverse();
}
//return index of item in listbox, which assosiated with given "req"-element. Otherwise return -1.
function searchReqElem(reqElem)
{
	var lb = gDialog.currentIds;
	for(var i = lb.getRowCount() - 1; i >= 0; i--)
	{
		var item = lb.getItemAtIndex(i);
		if(getReqElem(item) == reqElem) return i;
	}
	return -1;
}
//
function updateAddButton()
{
	// disable Ok button when there's no reqId text
    var enable = (TrimString(gDialog.idInput.value).length > 0) ? true : false;
    dialogNode.getButton("accept").disabled = !selectionIsEmpty || !enable;
}
//perfoms increments of id in field gDialog.idInput
function onInc()
{
    var val = gDialog.idInput.value.replace(/(^\s+|\s+$)/g,"");
    var slen = val.length;
    if ((slen > 0) && (val.charAt(slen - 1) == ";"))
    {
        val = val.substr(0, slen - 1);
    }
    //performs (unnamed)replacements as defines: replaces them by unique str, increments ids, and performs reverse replacement
    //array of additional defines
    var additional_defines = new Array();
    
    var reIDefine = /\[([^\[\]]*)\]/;
    var subst;
    while((subst = reIDefine.exec(val)) != null)
    {
		//replacement by unque string
		var first = val.substr(0, subst.index);
        var last = val.substr(subst.index + subst[0].length);
    	var define_symb = "@@" + additional_defines.length/*unique for all added "defines"*/ + "@@";
    	var define = new Object();
    	define.symb = define_symb;
    	define.strings = subst[0];
    	additional_defines.push(define);
    	val = first + define_symb + last;
    }
    
    var ids = val.split(";");
    var res = "";
    for(var ii=0;ii<ids.length;ii++)
    {
        res+=incReq(ids[ii]);
        if(ii<ids.length-1)
            res+=";";
    }
    //reverse replacement
    for(var i = additional_defines.length - 1; i >= 0; i--)
    {
    	var re = new RegExp(additional_defines[i].symb);
    	res = res.replace(re, additional_defines[i].strings);
    }
    gDialog.idInput.value = res;
    IdChanged();
}
//
function incNum(sym)
{
    var num = parseInt(sym, 10);
    if(!isNaN(num))
    {
        num++;
        var r = ""+num;
        while(r.length<sym.length) r = "0"+r;
        return r;
    }
    else return sym+"!";
}
//increment single recuirement id
function incReq(id)
{
    if(!reIndex.test(id)) return id;
    
    var first = id.replace(reIndex, "") + ".";//up to the dot
    var last = id.substring(first.length);// the last group of digits
    
    last = incNum(last);
    
    return (first + last);
}
//Verify whether can add requirement with identifier(s), containing in reqId, to the document
function ValidateData(reqId)
{
    var temp;
    var addition;
    
    if (reqId.length == 0)
    {
    	alert("Identificator should neither be empty string nor consist of spaces only.");
    	return false;
    }
    if(gActiveEditor.outputToString("text/html", 1)=="")
    {
        alert("No requirement text");
        return false;
    }
    
    var idList = Array();
    for(var j = 0; j < reqs.length; j++)
    {
        var exp_list = reqs[j].ids;
        for (var n = 0; n < exp_list.length; n++)
        {
            idList.push(exp_list[n]);
        }
    }
    var defines = GetDefines(gActiveEditor.document);
    var ids = expand_subst1(reqId, defines);
    //need for change in future
    for(var j = 0; j<ids.length; j++)
    {
        if (ids[j] == "") continue;
        
        temp = ids[j];
        if(isRef(temp))
        {
        	temp = stripRef(temp);
        	addition = true;
        }
        else
        {
        	addition= false;
        }
        
        if(addition)
        {
            var valid = false;
            for (var i = 0; i<idList.length; i++)
            {
                if(idList[i] == temp)
                {
                    valid = true;
                	break;
                }
            }
            if(!valid)
            {
                alert("No main requirement for "+ids[j]);
                return false;
            }
        }
        else
        {
        	temp = stripPrefixes(temp);
        	
            for (var i = 0; i<idList.length; i++)
            {
                if(temp == stripPrefixes(idList[i]))
                {
                    alert("ID collision for "+ids[j]);
                    return false;
                }
            }
        }
    }

    return true;
}
//overwrite requirement formulation in document(also support adding/removing this formulation)
function overwriteReq(reqElem, reqAltText)
{
	gActiveEditor.beginTransaction();
        
    if(reqAltText != "")
    {
        if((reqElem.lastChild == null) || (reqElem.lastChild.className!="form"))
        {
            //add
            var newNode = document.createElement("span");
            newNode.className = "form";
            newNode.style.display = "none";
            reqElem.appendChild(newNode);
        }
        //overwrite
        reqElem.lastChild.textContent = reqAltText;
    }
    else
    {
        if((reqElem.lastChild != null) && (reqElem.lastChild.className=="form"))
        {
            //remove
            reqElem.removeChild(reqElem.lastChild);
        }
    }
    gActiveEditor.incrementModificationCount(1);
    gActiveEditor.endTransaction();
}
//markup selected fragment in the document as requirement with given identifier and requirement text
function addReq(reqId, reqAltText)
{
	gActiveEditor.beginTransaction();
    try {
        //Creates req-element for inserting instead of selection
        var new_elem = gActiveEditor.createElementWithDefaults("span");
        //attributes in reverse order
        new_elem.id = reqId;
        new_elem.className = "req";
        //
        new_elem.innerHTML = gActiveEditor.outputToString("text/html", 1);
        
        if (reqAltText != "")
        {
            //Creates form-element
            var form_elem = gActiveEditor.createElementWithDefaults("span");
            //attributes in reverse order
            form_elem.style.display = "none";
            form_elem.className = "form";
            form_elem.textContent = reqAltText;
            //reqAltText = "<span class='form' style='display: none;'>"+reqAltText+"</span>";
            new_elem.appendChild(form_elem);
        }
       
        //gActiveEditor.insertHTML("<span class='req' id='"+reqId+"'>"+gActiveEditor.outputToString("text/html", 1)+reqAltText+"</span>");
        gActiveEditor.insertElementAtSelection(new_elem, true);
        
        correctTags(new_elem);
        
    } catch (e) {
        window.alert("Cannot add element: " + e.message);
        dump("Exception occured in insertHTML\n");
    } finally {
    	gActiveEditor.incrementModificationCount(1);
        gActiveEditor.endTransaction();
    }

}

/*
 * Bypass situation when the fragment markuped starts with some element(not TextNode or others non-elements DOM-nodes)
 * and this element ends INSIDE the fragment.
 * In such case Kompozer insert new "req" inside that element(and close tag after "req").
 * But also Kompozer open same tag INSIDE new "req"(at start).
 * 
 * So we need only remove external element.
 */

function correctTags(new_req)
{
	if(new_req.firstChild.nodeType == 3/*Text Node*/)return;// nothing to do
	var textNode = new_req.firstChild;
	//look for Text Node
	while(textNode && (textNode.nodeType != 3)) textNode = textNode.firstChild;
	if(!textNode) return;//smth. wrong, so stop
	
	var innerElement = textNode.parentNode, outerElement = new_req;
	while(innerElement && outerElement && (innerElement != new_req) && (outerElement.previousSibling == null))
	{
		var newParent = outerElement.parentNode;
		if(innerElement.tagName != newParent.tagName) break; //for assurence
		
		outerElement = newParent;
		innerElement = innerElement.parentNode;
		        			
	}
    if(outerElement == new_req)	return; //nothing to do
    //replace outerElement with new_req
    gActiveEditor.selectElement(outerElement);
    var clone_req = new_req.cloneNode(true);
    gActiveEditor.insertElementAtSelection(clone_req, true);

}
//delete given requirement from the document(and restore content as before this requirement was markuped)
function deleteReq(reqElem)
{
	gActiveEditor.beginTransaction();
    try
    {
        if(reqElem.lastChild != null && reqElem.lastChild.className == "form")
        {
        	//delete form-element
        	reqElem.removeChild(reqElem.lastChild);
        }
        //restore old content of the document
        var old_html = reqElem.innerHTML;
        gActiveEditor.selectElement(reqElem);
        
        gActiveEditor.insertHTML(old_html);
    } 
    finally
    {
        gActiveEditor.endTransaction();
    }
}
//form listbox according to list of requirements in the document and filter
function showIdsList(filter)
{
	var reFilter = new RegExp(filter);
	
	ClearListbox(gDialog.currentIds);
	listBoxReqs = new Array();
    for (var i = 0; i< reqs.length; i++)
    {
        var id = reqs[i].str_id;
        if(reFilter.test(id) == true)
        {
        	gDialog.currentIds.appendItem(id);
        	listBoxReqs.push(i);
        }
    }
}
//select req in listbox and adjust visibility; if index too large - select last element, if index less then zero - performs deselection
function selectReq(index)
{
	if(index < 0) index = -1;//deselection
	else if(index >= gDialog.currentIds.getRowCount()) index = gDialog.currentIds.getRowCount() - 1;//last element
	
	if(index >= 0) gDialog.currentIds.ensureIndexIsVisible(index);//adjust visibility
	gDialog.currentIds.selectedIndex = index;//selection
}
//called when value of the id-filter changed
function onFilterNow()
{
    var selectedItem = gDialog.currentIds.selectedItem;
    var selectedReq = selectedItem ? getReqElem(selectedItem) : null;
    
    gDialog.currentIds.setAttribute("suppressonselect", "true");
    //
    showIdsList(gDialog.filterExprInput.value);
    
    var indexInNewList = selectedReq ? searchReqElem(selectedReq) : -1;
    if(indexInNewList == -1 && mode == "view")indexInNewList = 0;//default in "view" mode
    selectReq(indexInNewList);
    
    gDialog.currentIds.setAttribute("suppressonselect", "false");
    //correct probable mismatch between selectionIsEmpty and the real selection in the listbox
    onSelected(gDialog.currentIds);
}
