var filesListBox;//listbox with source file(s)
/*
 * listelement:
 * label="path"
 * value="descriptor", all files in list should have unique descriptor
 */
var fileTextBox;//textbox with destination file

//called when selection is changed in the listbox of source files
function onSelected()
{
	updateRemoveButton();
}
//called when the field, containing path to destination file, changes
function onInput()
{
	updateAcceptButton();
}
function StartupCatalogueDlg()
{
	filesListBox = document.getElementById("SrcFilesList");
	fileTextBox = document.getElementById("fileTextBox");
	
	document.getElementById("ReqCatalogueDlg").getButton("accept").setAttribute("disabled","true");
	
	var filePath = window.arguments[0];
	if(filePath != null)
	{
		var file = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
		file.initWithPath(filePath);
		
		AddFileToList(file, filesListBox);
	}
}

function OnAddFile()
{
	var nsIFilePicker = Components.interfaces.nsIFilePicker;
	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

	fp.init(window, "Choose file(s) for get requirements", nsIFilePicker.modeOpenMultiple);
	fp.appendFilters(nsIFilePicker.filterAll | nsIFilePicker.filterHTML);
	if(fp.show() == nsIFilePicker.returnCancel) return;
	
	filesListBox.clearSelection();
	var lastItem = null;//for adjusting visibility
	for(filesEnumerator = fp.files; filesEnumerator.hasMoreElements() == true; )
	{
		var file = filesEnumerator.getNext().QueryInterface(Components.interfaces.nsILocalFile);
		var elem = AddFileToList(file, filesListBox);
		if(elem != null)
		{
			filesListBox.addItemToSelection(elem);
			lastItem = elem;
		}
	}
	if(lastItem) filesListBox.ensureElementIsVisible(lastItem);
}

function OnRemoveFile()
{
	while(filesListBox.selectedCount)
		RemoveFileFromList(filesListBox.selectedIndex, filesListBox);
}
function OnBrowseFile()
{
	var nsIFilePicker = Components.interfaces.nsIFilePicker;

	var fp = Components.classes["@mozilla.org/filepicker;1"].createInstance(nsIFilePicker);

	fp.init(window, "Save Catalogue of Requirements As", nsIFilePicker.modeSave);

	fp.appendFilters(nsIFilePicker.filterXML);
	fp.defaultExtension = "xml";

	if(fp.show() == nsIFilePicker.returnCancel) return;
	
	fileTextBox.value = fp.file.path;
	onInput();//content of fileTextBox changed
}

//****************************Additional functions
function getDocumentsURL()
{
	var documents = new Array();
	for(var i = 0; i < filesListBox.getRowCount(); i++)
	{
		documents.push(pathToURL(filesListBox.getItemAtIndex(i).label));
	}
	
	return documents;
}

function updateRemoveButton()
{
	var remove_button = document.getElementById("removeButton");
	remove_button.disabled = (filesListBox.selectedIndex < 0);
}
function isAcceptEnabled()
{
	return (fileTextBox.value != "") && (filesListBox.getRowCount() > 0)
}
function updateAcceptButton()
{
	var accept_button = document.getElementById("ReqCatalogueDlg").getButton("accept");	
	accept_button.disabled = !isAcceptEnabled();
}
//Add file to listbox. Return element, corresponding to the added file(new of existent)
function AddFileToList(file, listbox)
{
	var nItems = listbox.getRowCount();
	for(i = 0; i < nItems; i++)
	{
		var elem = listbox.getItemAtIndex(i);
		if(file.persistentDescriptor == elem.value) return elem;
	}
	var item = listbox.appendItem(file.path);
	item.setAttribute("crop", "start");
	updateAcceptButton();
	return item;
}
//Remove file from listbox. Return true on success, otherwise false.
function RemoveFileFromList(index, listbox)
{
	listbox.removeItemAt(index);
	updateAcceptButton();
	return true;
}

function PerformWritting(reqs)
{
	var collisions = check_collisions(reqs);
	if(collisions.length)
	{
		var dialog = window.openDialog("chrome://reqmarkup/content/requirements_viewer.xul",
				    "_blank", 
				    "chrome,close,titlebar,resizable",
					collisions
				);
		setTitle(dialog, "Non-unique identifiers encountered (" + collisions.length + ")");
		dialog.focus();
		return;
	}
	
	var outputPath = fileTextBox.value;
	var outputFile = Components.classes["@mozilla.org/file/local;1"].createInstance(Components.interfaces.nsILocalFile);
	try
	{		
		outputFile.initWithPath(outputPath);
	}
	catch(error)
	{
		window.alert("'" + outputPath + "' is not correct name of file for save catalogue.");
		return;
	}

	WriteCatalogue(reqs, outputFile);

	var promt = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
	/*promt.confirmEx(null,
					"Info",
					"catalogue was saved to file " + file.path,
					promt.BUTTON_POS_2 * promt.BUTTON_TITLE_OK,
					null, null ,null, null, {value: false}
					);*/
	promt.alert(null,
				"Info",
				"Catalogue was saved to file " + outputFile.path);
	
	window.close();
	return;
}


/*create object for collect reqs from documents
 *  documents - list of documents URLs;
 *  reqsProcessingFunction - function, which should be called after all reqs will be collected;
	 							array of collected reqs passed to this function as first parameter.
 */
function ReqsCollector(documents, reqsProcessingFunction)
{
	this.documents = documents;
	this.index = 0;//index of first document
	this.reqs = new Array();//array of currently collected reqs
	this.reqsProcessingFunction = reqsProcessingFunction;
	//start
	this.handleEvent();
}

ReqsCollector.prototype.handleEvent = function(event)
{
	var dialog = window.document.getElementById("ReqCatalogueDlg");
	if(event)//initiated by load-event, which fired when the document was loaded
	{
		var doc = event.target;
		var reqs = GetReqs(doc);
		if(reqs.length)
		{
			for(i = 0; i < reqs.length; i++)
			{
				reqs[i].src = doc.URL;
				reqs[i].rel_index = i;
			}
			
			this.reqs = this.reqs.concat(reqs);
		}
		//delete current frame
		var current_iframe = window.document.getElementById("id_iframe");
		if(current_iframe)dialog.removeChild(current_iframe);
	}
	
	if(this.index >= this.documents.length)
	{
		//this document was the last document in the listbox - call target function
		this.reqsProcessingFunction(this.reqs);
		return;
	}
	//create new frame and add "load"-listener to it
	var iframe = window.document.createElement("iframe");
	iframe.id = "id_iframe";
	iframe.collapsed = true;
	//iframe.hidden = true;//document is not loaded in Komposer
	dialog.appendChild(iframe);
	iframe.contentWindow.addEventListener("load", this, false);
	//load new document, this should be the last instruction
	iframe.setAttribute("src", this.documents[this.index++]);
}

function GenerateCatalogue()
{
	if(!isAcceptEnabled())return false;
	//
	var documents = getDocumentsURL();
	new ReqsCollector(documents, PerformWritting);

	return false;
}

function check_references_callback(reqs)
{
	var invalid_references = check_references(reqs);
	if(invalid_references.length)
	{
		var dialog = window.openDialog("chrome://reqmarkup/content/requirements_viewer.xul",
				    "_blank", 
				    "chrome,close,titlebar,resizable",
					invalid_references
				);
		setTitle(dialog, "References with absent targets encountered (" + invalid_references.length + ")");
		dialog.focus();
		return;
	}
	else
	{
		window.alert("All references are correct.")
	}
}
function CheckReferences()
{
	var documents = getDocumentsURL();
	new ReqsCollector(documents, check_references_callback);
}

function WriteCatalogue(reqs, file)
{
	var nsOS = Components.interfaces.nsIFileOutputStream;
	var outputStream = Components.classes["@mozilla.org/network/file-output-stream;1"].createInstance(nsOS);
	outputStream.init( file, -1, -1, 0 );
	var reqsNumber = reqs.length;
	
	var allReqs = new Object();
	
	var reqLen = reqs.length;
    for (i=0; i < reqLen; i++)
    { 
        var req = reqs[i];
        
        var ids = req.ids;

        var ids_len = ids.length;
        for(var thisid = 0; thisid < ids_len; thisid++ ) // ids
        {
            var str_id = "" + ids[thisid];
            if(isRef(str_id) == true)continue;// don't count refs
            
            var id = str_id.replace(reAttr, "");
            
            var reqObject = new Object(); // creating new REQ

            reqObject.id      = str_id;
            reqObject.txt     = req.altFormText || req.origFormText;
            
            allReqs[id] = reqObject;
        }
    }
    /* Now we have allReqs[str_id] - array of reqs. */
	for(var str_id in allReqs)
    {
        if(reIndex.test(str_id) == false) continue;
        var probParentId = str_id.replace(reIndex, "");

        if(allReqs[probParentId])
        	allReqs[probParentId].isParent = true;
    }
    var reqSort = new Array();
	for(var id in allReqs)
		reqSort.push(id);
	reqSort = reqSort.sort();
    //start
    /*var write_str = "<?xml version=\"1.0\"?>\n<requirements>\n";
    outputStream.write(write_str, write_str.length);
    
   
    for(var i in reqSort)
    {
    	var req = allReqs[reqSort[i]];
    	if(req.isParent) continue;
    	
		write_str = "<req id=\"" + req.id + "\">\n" + "    " + replace_xml_symbols(req.txt) + "\n</req>\n";;
		outputStream.write(write_str, write_str.length);
    }
    //end
    write_str = "</requirements>\n";
    outputStream.write(write_str, write_str.length);
    outputStream.close();*/
    
    var parser = new DOMParser();
	var doc = parser.parseFromString("<?xml version=\"1.0\"?>\n<requirements>\n</requirements>", "text/xml");
	var requrements_node = doc.getElementsByTagName("requirements")[0];
	for(var i in reqSort)
    {
		var req = allReqs[reqSort[i]];
		if(req.isParent) continue;
		
		var req_elem = doc.createElement("req");
		req_elem.setAttribute("id", req.id);
		
		var req_text = doc.createTextNode("\n    " + req.txt + "\n");
		req_elem.appendChild(req_text);
		
		requrements_node.appendChild(req_elem);
		requrements_node.appendChild(doc.createTextNode("\n"));
	}
	
	var serializer = new XMLSerializer();
	serializer.serializeToStream(doc, outputStream, /*"UTF-8"*/"");
	outputStream.close();

}
function replace_xml_symbols(str)
{
	str = str.replace(/&/g, "&amp;");
    str = str.replace(/</g, "&lt;");
    str = str.replace(/>/g, "&gt;");
    str = str.replace(/\'/g, "&apos;");
    str = str.replace(/\"/g, "&quot;");
    
    return str;
}

