var reqs;//array of requirements from document

var space = "    ";//for write template

var templateTextBox;

//return hash map of objects, describing reqs
function GenerateREQArray(reqs)
{
	var allReqs = new Array();

    var reqLen = reqs.length;
    for (i=0; i < reqLen; i++)
    { 
        var req = reqs[i];
        
        var ids = req.ids;

        var ids_len = ids.length;
        for(var thisid = 0; thisid < ids_len; thisid++ ) // ids
        {
            var str_id = "" + ids[thisid];
            if(isRef(str_id) == true)continue;// don't count refs
            
            var id = str_id.replace(reAttr, "");
            
            var reqObject = new Object(); // creating new REQ

            reqObject.id      = str_id;
            reqObject.altFormText     = req.altFormText;
            reqObject.origFormText    = req.origFormText;
            
            allReqs[id] = reqObject;
        }
    }
    /* Now we have allReqs[str_id] - array of reqs. */
    
    // Second pass. Determine parents.
    for(var id in allReqs)
    {
        if(reIndex.test(id) == false) continue;
        var probParentId = id.replace(reIndex, "");

        if(allReqs[probParentId])
        	allReqs[probParentId].isParent = true;
    }

	return allReqs;
}
function GetTemplate(reqs, filter_str)
{
    var allReqs = GenerateREQArray(reqs);
    // splitting by funcname
    var reFilter = RegExp(filter_str, "i");
    reqSplit = new Object();
    for(var id in allReqs)
    {
        var fname = getfname(id);
        if(!reFilter.test(fname))continue;
        if(!reqSplit[fname])
        {
            reqSplit[fname] = new Array();
        }
        
        reqSplit[fname].push(id);
    }   
    //sorted array of functions names
    var reqSplitSort = new Array();
    for(var fname in reqSplit)
    {
        reqSplitSort.push(fname);
    }
    
    reqSplitSort = reqSplitSort.sort();
    
    // ----------------------------------------------------
    // resCodeTemplatePre/Post generation. (Template Pre/Post)
    var text = "";
    for(var i in reqSplitSort)
    {
        var fname = reqSplitSort[i];
        
        text += "<BLOCK>\n\n<TARGETS>\n" + space;
        text += fname;
        text += "\n</TARGETS>\n\n<DEFINE>\n</DEFINE>\n\n<CODE>\n\n";
        
        var resCodeTemplatePre = "";
        var resCodeTemplatePost = "";
        
        var ids = reqSplit[fname];
        ids = ids.sort();
        for(var j in ids) // for a given target interface...
        {
            var id = ids[j];
            var elem = allReqs[id];
            var str_id = elem.id;

            if(elem.isParent) continue;// don't write parent reqs - they should be verified in the another place
            var reqTemplate = space + "/*\n";
            if (elem.origFormText != "")    
            {
                // display the original requirement text in the comment
                reqTemplate += formatCommentText (elem.origFormText);
            }
            if (elem.altFormText != "")    
            {
                // display the alternative requirement text in the comment
                if (elem.origFormText != "") 
                {
                    reqTemplate += space + " *\n";
                }
                reqTemplate += formatCommentText ("[" + elem.altFormText + "]");
            }
            
            reqTemplate += space + " */\n\n";
            
            var stub = "TODO_REQ()";

            // REQ("id",..,..);
            reqTemplate += space + "REQ(\"" + str_id + "\", \"\", " + stub + ");\n\n";
            
            if(isApp(str_id))
            {
                resCodeTemplatePre += reqTemplate;
            }
            else // no "app" prefix
            {
                resCodeTemplatePost += reqTemplate;
            } // end if isApp
        } // end for j in ...
        
        text += resCodeTemplatePre;
        text += resCodeTemplatePost;
        
        text += "</CODE>\n\n<PURPOSE>\n</PURPOSE>\n\n</BLOCK>\n"
        text += "\n#===============================================================================\n\n";
    }
    return text;
    // end of resCodeTemplatePre/Post generation. (Template Pre/Post)
    // ----------------------------------------------------
} // end of GetTemplate

function StartupTemplateDlg()
{
	reqs = window.arguments[0];

	templateTextBox = document.getElementById("templateTextBox");

	GenerateTemplate();
}
function GenerateTemplate()
{
	templateTextBox.value = GetTemplate(reqs, document.getElementById("filterTextBox").value);
}

// Splits the text into several lines up to 72 characters each,
// inserts [space] and " *" before each line and returns the result.
function formatCommentText(txt)
{
    if (!txt) return null;
    
    // remove leading & trailing whitespace chars as well as newlines
    txt = txt.replace(/(^\s+|\s+$)/g,""); 
    txt = txt.replace(/[\n\r]+/g," "); 
    
    txt += "\n";
    
    var text = "";
    var l = 0;
    while(l < txt.length)
    {
        txt.substr(l).match(/(.{0,71}\S|)(\s\n|\n|\s)/);
        l += RegExp.$1.length + RegExp.$2.length;
        text += space + " * " + RegExp.$1 + "\n";
    }
    
    return text;
}
function onCopyAllToClipboard()
{
	try
	{
		var editor = templateTextBox.inputField.editor;//only this causes komposer to fail
		
		//var editor = document.getElementById("templateTextBox").inputField.editor;
		//var editor = document.getElementById("filterTextBox").inputField.editor;
		//window.alert("t:" + t + "; t.inputField.editor:" + t.inputField.editor);
		//editor.selectAll();
		/*if(editor.canCopy() == false)
		{
			window.alert("Cannot copy");
		}
		else
		{
			editor.copy();
		}*/
		//t.emptyText = "123";
	}
	catch(error)
	{
		window.alert('onCopyAllToClipboard: ' + error.message);
	}
}
