var reAttr = new RegExp ("^[#\$!]*(ext\\.|app\\.)*");
var reRef = new RegExp ("^&");
var reIndex = new RegExp ("(\\.\\d+)$");
var reIndices = new RegExp ("(\\.\\d+)*$");

/*
 * str_id ->
 * .replace(reRef,"") ->
 * .replace(reAttr,"")->
 * id->
 * .replace(reIndeces,"")->
 * function_name
*/

/* 
 * If exist,
 * parent_id == id.replace(reIndex, "")
 */
 
/*
 * reAttr.match(str_id_without_ref) should return array of (some) attribute substrings
 */
var reIDefine = /\[([^\[\]]*)\]/;//match to most-inner unnamed substitution
//var reLine = new RegExp ("(.{0,71}\\S|)(\\s\\n|\\n|\\s)", "g");

// strip symbol '&' from the begining of str_id, if it is.
function stripRef(str_id)
{
	return str_id.replace(reRef,"");
}
//
function isRef(str_id)
{
	return reRef.test(str_id);
}
//
function isApp(str_id)
{
	str_id = stripRef(str_id);
	//
	var attributes = str_id.match(reAttr);
	//return attributes.indexOf("app.") != -1; don't work with Kompozer
	var i;
	for(i in attributes)
	{
		if(attributes[i] == "app.") return true;
	}
	return false;
	
}
// Returns original formulate of the requirement, containing in element
// Result is string wihtout new-lines; all spaces treated as whitespace;may be other replacement
// If second argument is omitted, it assumes equal to el.ownerDocument
function getElementText(el, document)
{
    if(!document) document = el.ownerDocument;
    var result = "";

    var treeWalker = document.createTreeWalker(el,
    		NodeFilter.SHOW_ELEMENT | NodeFilter.SHOW_TEXT,
    		null,
    		false);

	var node;
	while(node = treeWalker.nextNode())
	{
		if(node.nodeType == 1)//Element
		{
			if(node.className == "form") break;
			else if(node.tagName.toLowerCase() == "br") result += "\n";
		}
		else if(node.nodeType == 3)//Text Node
		{
			result += node.nodeValue;
		}
	}
   
    result = TrimString(result).replace(/\s+/g, " ");
    
    return result;
}
function getElementTextAlt(el)
{
	try
	{
		var result = "";
		var lastChild = el.lastChild;
		if(lastChild && lastChild.className == "form")
		{
			//result = lastChild.textContent;
			result = lastChild.firstChild.nodeValue;
			//may be result formatting here
		}
		
		return result;
	}
	catch(err)
	{
		window.alert("getElementTextAlt:" + err.message);
	}
}
// Strips prefixes from the specified string and returns the result.
function stripPrefixes(str_id)
{
    return str_id.replace(reAttr, "");
}

// returns function name for a given ID
function getfname(id)
{
    return id.replace(reIndices, "");
}
/*
 * For given id, containing(may be) substitutions, named(define) or unnamed
 * returns expansion as array of strings
 * after corresponding substitutions into id.
 */
function expand_subst(id, defines) {
    var ids = new Array(id);
    do {
        var subst_done = true;
        var ids_len = ids.length;
        var new_ids = new Array();
        for(var thisid=0; thisid<ids_len; thisid++ ) {
            var id = ""+ids[thisid];
            var replaced = false;
            //expand unnamed substitutions
            var subst = reIDefine.exec(id);
            if(subst)
            {
            	subst_done = false;
            	first = id.substr(0, subst.index);
            	last = id.substr(subst.index + subst[0].length);
            	var subst_strings = subst[1].split(";");
            	for(var str_i in subst_strings)
            	{
            		var sub_str = subst_strings[str_i];
            		sub_str = sub_str.replace(/^\s+/, "").replace(/\s+$/, "");
            		if(sub_str == "") continue;
            		new_ids.push(first + sub_str + last);
            		replaced = true;
            	}
            	if(!replaced) new_ids.push(first + last);
				continue;//next id
            }
            //expand defines
            for ( var symb in defines ) {
                if ( defines[symb].matcher.test(id)) {
                    replaced = true;
                    subst_done = false;
                    for (var str_i in defines[symb].strings_array) {
                        var str = defines[symb].strings_array[str_i];
                        var id_tmp = id;
                        id_tmp = id_tmp.replace(defines[symb].matcher, str);
                        new_ids.push(id_tmp);
                    }
                    break;
                }
            }
            if (!replaced) {
                new_ids.push(id);
            }
        }
        ids = new_ids;
    }while (!subst_done);
    return ids;
}
//same but for string of ids, rather then for one id
function expand_subst1(id_string, defines)
{
	return expand_subst("[" + id_string + "]", defines);
}
/*
 * Create obj with description of define, containing in html-elemement(elem should have class 'define')
 */

function DefineInfo(elem)
{
	this.symb = "" + elem.name;
    this.strings = "" + elem.title;
}
// return array of string which should be substitute instead of define-name
function split_define_str(str)
{
    //same as req(without defines)
    return expand_subst1(str, null);
}
//return hash-map of defines	
function GetDefines(document)
{
    var treeWalker = document.createTreeWalker(document,
			NodeFilter.SHOW_ELEMENT,
			{ acceptNode: function(node){return (node.className == "define") ? NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_SKIP;} },
			false);

	var defines = new Object();
	var c;
	while(c = treeWalker.nextNode())
	{
		var defineInfo = new DefineInfo(c);

        define_object = new Object();
        define_object.matcher = new RegExp(defineInfo.symb, "");
        define_object.strings_array = split_define_str(defineInfo.strings);
        
        defines[defineInfo.symb] = define_object;
	}
    return defines;
}

/*
 * Return obj with description of req, containing in elem(elem should have class 'req'):
 *   - title - (value of property title)
 *   - str_id - string of identifiers(value of property id)
 *   - origFormText - original formulation of the requirement
 *   - altFormText - alternative formulation of the requirement, if given. Otherwise "".
 */
function ReqInfo(elem, document)
{
    this.title = "" + elem.title;
    this.str_id = "" + elem.id;
    // requirement text & its alternative formulation
    this.origFormText = getElementText(elem, document);
    this.altFormText = getElementTextAlt(elem);
}

/*
 * Return Array(not hash map!) of elements, describing req
 *
 *   - title - (value of property title)
 *   - str_id - string of identifiers(value of property id)
 *   - origFormText - original formulation of the requirement
 *   - altFormText - alternative formulation of the requirement, if given. Otherwise "".
 *   - c - html - element, containing this req
 *   - ids - array of ids, formed with expand_subst1(). So one need't document or defines for the next processing of the result of this function.
 */
function GetReqs(document)
{
	var defines = GetDefines(document);
	var reqs = new Array();

	var treeWalker = document.createTreeWalker(document.body,
		NodeFilter.SHOW_ELEMENT,
		{ acceptNode: function(node){return (node.className == "req") ? NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_SKIP;} },
		false);
	var c;
	while(c = treeWalker.nextNode())
	{
		var req = new ReqInfo(c, document);
        req.ids = expand_subst1(req.str_id, defines);
        req.c = c;
        
        reqs.push(req);
	}
	return reqs;
}

/*
 * 		Format of data for requirement_viewer:
 * data is Array of:
 * 	data[i].label - text of parent rows
 * 	data[i].requirements - Array
 * 	data[i].requirements[j].label - requirement str_id
 * 	data[i].requirements[j].location - document_filename:ordinal_index_of_the_requirement_in_the_document
 *  									document_filename == "" means current window(accessed via GetCurrentEditor())
 */

//create new grouping element for requirement_viewer
function GroupingElement(label)
{
	this.label = label;
	this.requirements = new Array();
}
GroupingElement.prototype.addRequirement = function(requirementInfo)
{
	this.requirements.push(requirementInfo);
}
/* 
 * Create new object, containing information about requirement, for requirement_viewer.
 *  reqs - array of reqs
 *  index - index of the requirement in reqs
 */
function RequirementInfo(reqs, index)
{
	var req = reqs[index];
	this.label = req.str_id || "(empty identifier)";

	this.location = reqs[index].src ? (reqs[index].src + ":" + reqs[index].rel_index) : (":" + index);

	return this;
}
//return array of collisions in format for requirement_viewer (if no collisions, array is empty)
function check_collisions(reqs)
{
	var collisions = new Array();//format for requirements_viewer.js
	var empty_ids = new Array();//afterall will be included into collisions
	//this will be associative container of existing ids; properties of values: index - index of first requirement in reqs, collision_index - index in collisions
	var allReqs = new Object();
    
    var reqsLen = reqs.length;
    for (i=0; i<reqsLen; i++)
    { 
        var req = reqs[i];
        
        var ids = req.ids;

        var ids_len = ids.length;
        for(var thisid = 0; thisid < ids_len; thisid++ ) // ids
        {
            var str_id = "" + ids[thisid];
            if(isRef(str_id) == true)continue;//don't process refs - for them there is an additional checking function
            
            var id = str_id.replace(reAttr, "");
            
            if (id == "") // checking if the id is empty 
            {
                empty_ids.push(i);
                continue;
            }
            if(allReqs[id]) // checking collisions
            {
                var collision_req = allReqs[id];
                if(collision_req.collision_index == null/*really - undefined*/)
                {
                	//create new collisions-element with first element - first requirement, which has this id
                	var first_req = reqs[collision_req.index];
                	collision_req.collision_index = collisions.length;
					//
                	var collision = new GroupingElement(id);
                	collision.addRequirement(new RequirementInfo(reqs, collision_req.index));
                	collisions.push(collision);
                }
                //add new requirement to the collisions
                collisions[collision_req.collision_index].addRequirement(new RequirementInfo(reqs, i));
                continue;
            }
            allReqs[id] = {index : i};
            //allReqs[id].index = i;
        }
    }
    if(empty_ids.length != 0)
    {
    	var collision = new GroupingElement("(empty identifiers)");//formed as a collision element
    	for(var i = 0; i < empty_ids.length; i++)
    	{
            collision.addRequirement(new RequirementInfo(reqs, empty_ids[i]));
    	}
    	//
    	collisions.unshift(collision);//added to the beginning of collision-array
    }
	return collisions;
}
//return array of references with missing target in format for requirement_viewer (if all references are correct, array is empty)
function check_references(reqs)
{
	var invalid_references = new Array();//format for requirements_viewer.js
	//this will be associative container of existing ids(not references);
	//plus it will contain invalide refs with collision_index-property - index in invalid_references array
	var allReqs = new Object();
    var refs = new Array();//array of refs; index - index in reqs, str_id - identifier string
    var reqsLen = reqs.length;
    //collect not-refs into assiciative array and refs into array
    for (i=0; i<reqsLen; i++)
    { 
        var req = reqs[i];
        
        var ids = req.ids;

        var ids_len = ids.length;
        
        for(var thisid = 0; thisid < ids_len; thisid++ ) // ids
        {
            var str_id = "" + ids[thisid];
            if(isRef(str_id) == true)
            {
            	refs.push({index : i, str_id : str_id})
            }
            
            var id = str_id.replace(reAttr, "");
            
            allReqs[id] = {};
        }
    }
    var refsLen = refs.length;
    //verify references
    for(var i = 0; i < refsLen; i++)
    {
    	var str_id = refs[i].str_id;
    	var id = stripPrefixes(stripRef(str_id));
    	if(allReqs[id] && allReqs[id].collision_index == undefined) continue;//reference is correct
    	
    	var requirement = new RequirementInfo(reqs, refs[i].index);
    	if(allReqs[id])
    	{
    		//such reference is not first
    		invalid_references[allReqs[id].collision_index].addRequirement(requirement);
    	}
    	else
    	{
    		//first occure of such reference
    		allReqs[id] = {collision_index : invalid_references.length};
    		var collision = new GroupingElement(id);
            collision.addRequirement(requirement);
           	invalid_references.push(collision);
    	}
    }
	return invalid_references;
}
//****************Functions not relating to requirements********************************
//convert URL to local filename; if URL is special("about:blank"), return null
function urlToPath(URL)
{
	var reURL = new RegExp("^file://");
	var path;
	if(reURL.test(URL) == false) return null;
	
	var path = URL.replace(reURL, "");
	var reWin = new RegExp("^/\\w:/");
	if(reWin.test(path) == true)
	{
		//windows filesystem?
		path = path.replace(new RegExp("/", "g"), "\\").substr(1);
	}
	//window.alert("path: " + path);
	return path;
}
//convert local filename to URL
function pathToURL(path)
{
	var URL = path;
	if(URL[0] != "/") URL = "/" + URL.replace(new RegExp("\\\\", "g"), "/");//window filesystem
	URL = "file://" + URL;
	//window.alert("URL: " + URL);
	return URL;
}
//set title for window(because window may not be loaded yet, title will be set after 'focus' event)
function setTitle(win, title)
{
	win.addEventListener('focus',
		function(event)
		{
			event.currentTarget.removeEventListener(event.type, arguments.callee, false);
			//window.alert("target: " + event.target);
			event.currentTarget.document.title = title;
		},
		false);
}