var tabs = new Array(); 	//tabs[id].TemplateDialog - window containing template

var lastId = "";

// if (typeof Element != 'undefined' && Element.prototype && document.createRange)
if (typeof Element != 'undefined' && typeof Element != 'function' && Element.prototype && document.createRange)  
{
   Element.prototype.__defineGetter__(
     'innerText',
     function () {
       var range = document.createRange();
       range.selectNodeContents(this);
       return range.toString();
     }
   );
   Element.prototype.__defineSetter__(
     'innerText',
     function (text) {
       var range = document.createRange();
       range.selectNodeContents(this);
       range.deleteContents();
       this.appendChild(document.createTextNode(text));
     }
   ); 
}

function getLastId()
{
    //<>
    //alert("Get " + lastId);
    //<>
    
    return lastId;
}

function setLastId(id)
{
    lastId = id;
    
    //<>
    //alert("Set " + lastId);
    //<>
}

function OpenReqDiag()
{
    try
    {
	    //determine mode
	    var mode, elem;
	    var gActiveEditor = GetCurrentEditor();
	    var containerElement = gActiveEditor.getSelectionContainer();
	    while(containerElement && containerElement.className != "req") containerElement = containerElement.parentNode;
	    if(containerElement)
	    {
	    	//inside already marked requirement
	    	mode = "view";
	    	elem = containerElement;
	    }
	    else
	    {
	    	//not inside already marked requirement
	    	if(gActiveEditor.selection.isCollapsed)
	    	{
	    		//empty selection
	    		mode = "view";
	    		elem = null;
	    	}
	    	else
	    	{
	    		
	    		var new_elem = gActiveEditor.document.createElement("span");
		        new_elem.innerHTML = gActiveEditor.outputToString("text/html", 1);
		        //look for "req" elem inside selection
		        var treeWalker = gActiveEditor.document.createTreeWalker(new_elem,
								NodeFilter.SHOW_ELEMENT,
								{ acceptNode: function(node){return (node.className == "req") ? NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_SKIP;} },
								false);
				if(!treeWalker.nextNode())
				{
					//selection does not intersect with already marked requirement
					mode = "add";
				}
				else
				{
					//selection intersects with already marked requirement - error
					alert("Adding requirement, which intersects with already marked one, is forbidden.");
					return;
				}
								
	    	}
	    }
	    
	    window.openDialog("chrome://reqmarkup/content/EdReqProps.xul",
	        "_blank", 
	        "chrome,close,titlebar,modal,resizable",
	        mode,
	        mode == "view" ? elem : getLastId,
	        setLastId);
	    window.content.focus();
	}
	catch(err)
	{
		window.alert("Cannot open reqDialog: " + err.message);
	}
}

function Highlight()
{
    var gActiveEditor = GetCurrentEditor();
    var document = gActiveEditor.document;
    
    gActiveEditor.incrementModificationCount(1);
    
    var style;
    if((style=document.getElementById('reqstyle')) != null)
    {
        document.getElementsByTagName('head')[0].removeChild(style);
        return;
    }
    
    style = document.createElement('style');
    style.id = 'reqstyle';

    document.getElementsByTagName('head')[0].appendChild(style);
    var stylesheet = document.styleSheets[document.styleSheets.length - 1];
    var ownerNode = stylesheet.ownerNode;
    var textNode = document.createTextNode("\n.req { background-color: rgb(255, 255, 153);}\n");
    ownerNode.appendChild(textNode);
}

function RemoveMarkup()
{
    if (confirm("Are you sure you want to completely remove requirement markup?"))
    {   
        var gActiveEditor = GetCurrentEditor();
        var document = gActiveEditor.document;
        
        gActiveEditor.beginTransaction();
        
        try
        {
            // remove req markup
            do
            {
                var smthRemoved = false;
                
                var coll = document.getElementsByTagName("*");
                for(i = 0; i < coll.length; i++)
                {
                    var nreq = coll[i];

                    if(nreq.className=="req")
                    {
                        if(nreq.lastChild != null)
                        {
                            if(nreq.lastChild.className=="form")
                            {
                                nreq.removeChild(nreq.lastChild);
                            }
                        }
                        
                        var childNodes = nreq.childNodes;
                        for (var ch = 0; ch < childNodes.length; ch++)
                        {
                            var node = childNodes[ch].cloneNode(true);
                            nreq.parentNode.insertBefore(node, nreq);
                        }
                        nreq.parentNode.removeChild(nreq);
                        
                        smthRemoved = true;
                    }
                    else if (nreq.className=="define")
                    {
                        nreq.parentNode.removeChild(nreq);
                    }
                }
            } 
            while (smthRemoved);
            
            //remove code template
            var tmpl = document.getElementById("template");
            if (tmpl)
            {
                tmpl.parentNode.removeChild(tmpl);
            }
            
            //remove req style
            var rstl = document.getElementById("reqstyle");
            if (rstl)
            {
                rstl.parentNode.removeChild(rstl);
            }
        }
        finally
        {
            gActiveEditor.incrementModificationCount(1);
            gActiveEditor.endTransaction();
        }
    }
}

function ShowTemplate()
{
    var document = GetCurrentEditor().document;
    var reqs = GetReqs(document);
    var collisions = check_collisions(reqs);
    if(collisions.length != 0)
    {
		//there are id-collisions in the document
		var dialog = window.openDialog("chrome://reqmarkup/content/requirements_viewer.xul",
			    "_blank", 
			    "chrome,close,titlebar,resizable",
				collisions
			);
		setTitle(dialog, "Non-unique identifiers encountered (" + collisions.length + ")");
		dialog.focus();
    }
	else
	{
		var dialog = window.openDialog("chrome://reqmarkup/content/ShowTemplate.xul",
			    "_blank", 
			    "chrome,close,titlebar,resizable, modal",
				reqs
			);
		dialog.focus();
	}
}

function ReqCatalogue()
{
	var URL = GetCurrentEditor().document.URL;

	var dialog = window.openDialog("chrome://reqmarkup/content/ReqCatalogue.xul",
		    "_blank", 
		    "chrome,close,titlebar,resizable",
		    urlToPath(URL)
		);
	dialog.focus();
}

function Defines()
{
	var dialog = window.openDialog("chrome://reqmarkup/content/EdDefines.xul",
		    "_blank", 
		    "chrome,close,titlebar,resizable, modal"
		);
	dialog.focus();
}