var dialogDocument;
var treeObject;
var windows = {};// associative container of windows, containing documents

/*
 * Arguments:
 *	0 - data for output
 */

function Startup()
{
	dialogDocument = window.document;
	treeObject = dialogDocument.getElementById("requirementsTree");
	if(GetCurrentEditor())
	{
		windows[""] = GetCurrentEditor().document.defaultView;
	}
	
	treeObject.addEventListener("dblclick", onTreeDblClick, false);

	var data = window.arguments[0];
	loadTree(data);
}

//switch to the requirement in the document
function findReq(win, index_in_document)
{
	var current_index = -1;
	var doc = win.document;
	var treeWalker = doc.createTreeWalker(doc.body,
    		NodeFilter.SHOW_ELEMENT | NodeFilter.SHOW_TEXT,
    		{ acceptNode: function(node)
    			{
    				if (node.className != "req")return NodeFilter.FILTER_SKIP;
    				current_index++;
    				return (current_index == index_in_document) ? NodeFilter.FILTER_ACCEPT : NodeFilter.FILTER_REJECT;
    			}
    		},
    		false);
    var req = treeWalker.nextNode();
    if(!req) return;// req not found

    var scrollX = 0, scrollY = 0;
    for(var elem = req; elem && elem != doc; elem = elem.offsetParent)
    {
    	scrollX += elem.offsetLeft;
    	scrollY += elem.offsetTop;    	
    }
    win.scrollTo(scrollX, scrollY);
}

//return treeitem-element, containing info about requirement
function createRequirementElement(data_requirement)
{
	var item = dialogDocument.createElement("treeitem");
	var row = dialogDocument.createElement("treerow")
	var cell = dialogDocument.createElement("treecell");
	cell.setAttribute("value", data_requirement.location);
	cell.setAttribute("label", data_requirement.label);
	row.appendChild(cell);
	item.appendChild(row);
	return item;
}
//return treeitem-element, which group other elements(last child - treechildren-element)
function createGroupingElement(data_element)
{
	var item = dialogDocument.createElement("treeitem");
	item.setAttribute("container", true);
	var row = dialogDocument.createElement("treerow");
	var cell = dialogDocument.createElement("treecell");
	cell.setAttribute("label", data_element.label);
	row.appendChild(cell);
	item.appendChild(row);
	item.appendChild(dialogDocument.createElement("treechildren"));
	
	return item;
}

function loadTree(data)
{
	var treeContent = dialogDocument.getElementById("requirementsTreeContent");
	//debug : when tree initially not empty
	while(treeContent.firstChild)treeContent.removeChild(treeContent.firstChild);
	
	for(var i = 0; i < data.length; i++)
	{
		var data_element = data[i];
		//
		var grouping_item = createGroupingElement(data_element);
		var groupingContent = grouping_item.lastChild;
		
		var data_requirements = data_element.requirements;
		for(var j = 0; j < data_requirements.length; j++)
		{
			var data_requirement = data_requirements[j];
			//
			groupingContent.appendChild(createRequirementElement(data_requirement));
		}
		treeContent.appendChild(grouping_item);
	}
}

function onTreeDblClick(event)
{
	var boxObject = treeObject.treeBoxObject;
	var row = {}, col = {}, cell = {};
	boxObject.getCellAt(event.clientX, event.clientY, row, col, cell);
	
	onFindRequirement(row.value);
}

function onFindRequirement(row)
{
	if(row == -1) return;//no selection, or dblclick not on the item
	if(treeObject.view.isContainer(row))return;//not a row, containing requirement

	var column = "requirements";
	
	var location = treeObject.view.getCellValue(row, column);

	for(colon_position = location.length - 1; colon_position >= 0 && location[colon_position] != ':'; colon_position--);
	
	var URL = location.substring(0, colon_position);
	var index_in_document = +location.substring(colon_position + 1);
	
	if(!windows[URL] || windows[URL].closed)
	{
		windows[URL] = window.open(URL, "documents");
		if(windows[URL].closed) return;//smthing wrong
	}

	findReq(windows[URL], index_in_document);

	windows[URL].focus();
}